## minexpert2 9.2.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -13,7 +13,7 @@
 
 set(LOWCASE_PROJECT_NAME minexpert2)
 
-set(VERSION 9.2.0)
+set(VERSION 9.2.1)
 
 # Set additional project information
 set(COMPANY "msXpertSuite.org")
