## minexpert2 9.2.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -13,7 +13,7 @@
 
 set(LOWCASE_PROJECT_NAME minexpert2)
 
-set(VERSION 9.2.1)
+set(VERSION 9.2.2)
 
 # Set additional project information
 set(COMPANY "msXpertSuite.org")
@@ -236,22 +236,6 @@
 message(STATUS "Adding subdirectory doc for project: ${TARGET}")
 add_subdirectory(doc)
 
-#############################################################
-####################
-# BUILD OF THE TESTS
-if(MAKE_TESTS)
-  #MESSAGE("MAKE_TEST was set to ${MAKE_TEST}")
-  enable_testing()
-  include(CTest)
-
-  if(BUILD_TESTING)
-
-    add_subdirectory(tests)
-
-  endif(BUILD_TESTING)
-
-endif()
-
 
 # Use all the configured paths to create the config.h file.
 # The config file is binary directory-specific !!!
@@ -343,3 +327,10 @@
 
 if(LOCAL_DEV)
   message("")
+  message("${BoldGreen}USING LOCAL DEVELOPMENT CONFIG FOR PAPPSOMSPP")
+  message("")
+endif()
+
+message("")
+message(STATUS "${BoldRed}~~~~~~~~~~~~~~~~~~~~~~~~ SUMMARY ~~~~~~~~~~~~~~~~~~~~~~~~${ColourReset}")
+message("")
