=== src/CMakeLists.txt ===
--- 
+++ 
@@ -68,6 +68,8 @@
   #
   gui/TaskMonitorCompositeWidget.cpp
   gui/TaskMonitorWnd.cpp
+  #
+  gui/TicChromPreviewerMassDataLoadDlg.cpp 
   #
   # The ms run data set tree view classes
   gui/MsRunDataSetTableViewWnd.cpp
@@ -160,6 +162,7 @@
   gui/ui/XicExtractionWnd.ui
   gui/ui/AnalysisPreferencesDlg.ui
   gui/ui/ScriptingWnd.ui
+  gui/ui/TicChromPreviewerMassDataLoadDlg.ui
 )
 
 qt6_wrap_ui(${TARGET}_UIS_H ${${TARGET}_UIS})
@@ -256,6 +259,7 @@
   Qt6::PrintSupport
   Qt6::Xml
   Qt6::Network
+  Qt6::Sql
 )
