=== src/CMakeLists.txt ===
--- 
+++ 
@@ -8,12 +8,17 @@
   # Some globals.
   nongui/globals.cpp
   #
+  # The classes to look into an MS run prior to loading it
+  nongui/MsRunProber.cpp
+  nongui/vendor/BrukerTimsTofMsRunProber.cpp
+  #
   # The main class that hold the mass data.
   nongui/MsRunDataSet.cpp
   #
   # The class to handle the statistics computation about a given MsRunDataSet.
   nongui/MsRunDataSetStats.cpp
-
+  #
+  # The class to load MS run data
   nongui/MassSpecDataFileLoader.cpp
   #
   # The classe that monitors integrators.
@@ -63,13 +68,14 @@
   gui/ConsoleWnd.cpp
   #
   gui/MsRunReadTask.cpp
+  gui/MsRunProbeTask.cpp
   #
   gui/OpenMsRunDataSetsDlg.cpp
   #
   gui/TaskMonitorCompositeWidget.cpp
   gui/TaskMonitorWnd.cpp
   #
-  gui/TicChromPreviewerMassDataLoadDlg.cpp 
+  gui/MsRunProbeInfoViewerDlg.cpp 
   #
   # The ms run data set tree view classes
   gui/MsRunDataSetTableViewWnd.cpp
@@ -162,7 +168,7 @@
   gui/ui/XicExtractionWnd.ui
   gui/ui/AnalysisPreferencesDlg.ui
   gui/ui/ScriptingWnd.ui
-  gui/ui/TicChromPreviewerMassDataLoadDlg.ui
+  gui/ui/MsRunProbeInfoViewerDlg.ui
 )
 
 qt6_wrap_ui(${TARGET}_UIS_H ${${TARGET}_UIS})
