=== debian/control ===
--- 
+++ 
@@ -11,6 +11,7 @@
  qt6-base-dev,
  libqt6svg6-dev,
  libqt6core5compat6-dev,
+ libxkbcommon-x11-dev,
  cmake,
  daps,
  libjs-jquery,
@@ -22,8 +23,8 @@
  libisospec++-dev,
  libquazip1-qt6-dev,
  zlib1g-dev,
- libpappsomspp-dev (>= 0.9.12),
- libpappsomspp-widget-dev (>= 0.9.12),
+ libpappsomspp-dev (>= 0.9.20),
+ libpappsomspp-widget-dev (>= 0.9.20),
  docbook-xml,
  docbook-to-man
 Standards-Version: 4.6.2
